<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::entropy_encoder_model_kernel_2&lt; alphabet_size, entropy_encoder, cc, ccbig &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html">entropy_encoder_model_kernel_2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1entropy__encoder__model__kernel__2-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::entropy_encoder_model_kernel_2&lt; alphabet_size, entropy_encoder, cc, ccbig &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a0e6ea81ec57a5d041a6e0482f30a310a"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html#a0e6ea81ec57a5d041a6e0482f30a310a">entropy_encoder_type</a></td></tr>
<tr class="separator:a0e6ea81ec57a5d041a6e0482f30a310a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a50c7097f11c0e64d898cad35d8e00d54"><td class="memItemLeft" align="right" valign="top"><a id="a50c7097f11c0e64d898cad35d8e00d54"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_encoder_model_kernel_2</b> (<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;coder)</td></tr>
<tr class="separator:a50c7097f11c0e64d898cad35d8e00d54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0d1c712c40306944a95d35208437c86"><td class="memItemLeft" align="right" valign="top"><a id="ae0d1c712c40306944a95d35208437c86"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:ae0d1c712c40306944a95d35208437c86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7357aea0647ef86a29fcaa007e9c2420"><td class="memItemLeft" align="right" valign="top"><a id="a7357aea0647ef86a29fcaa007e9c2420"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>encode</b> (unsigned long symbol)</td></tr>
<tr class="separator:a7357aea0647ef86a29fcaa007e9c2420"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49b473b154bb287dee90aca706c83c9d"><td class="memItemLeft" align="right" valign="top"><a id="a49b473b154bb287dee90aca706c83c9d"></a>
<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>get_entropy_encoder</b> ()</td></tr>
<tr class="separator:a49b473b154bb287dee90aca706c83c9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ad70b902a3e771698b10a5f00c09f9796"><td class="memItemLeft" align="right" valign="top"><a id="ad70b902a3e771698b10a5f00c09f9796"></a>
static unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_alphabet_size</b> ()</td></tr>
<tr class="separator:ad70b902a3e771698b10a5f00c09f9796"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a78aa1e086d959a8b99b69aecd669231e"><td class="memItemLeft" align="right" valign="top"><a id="a78aa1e086d959a8b99b69aecd669231e"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>entropy_encoder_model_kernel_2</b> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html">entropy_encoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, cc, ccbig &gt; &amp;)</td></tr>
<tr class="separator:a78aa1e086d959a8b99b69aecd669231e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae47e19880a44b6ab2388f081451ae049"><td class="memItemLeft" align="right" valign="top"><a id="ae47e19880a44b6ab2388f081451ae049"></a>
<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html">entropy_encoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, cc, ccbig &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html">entropy_encoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, cc, ccbig &gt; &amp;)</td></tr>
<tr class="separator:ae47e19880a44b6ab2388f081451ae049"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3dc5c170302a6fb8021036daa30d756b"><td class="memItemLeft" align="right" valign="top"><a id="a3dc5c170302a6fb8021036daa30d756b"></a>
<a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>coder</b></td></tr>
<tr class="separator:a3dc5c170302a6fb8021036daa30d756b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a873a8458d5c75fa31e514198043b7f"><td class="memItemLeft" align="right" valign="top"><a id="a5a873a8458d5c75fa31e514198043b7f"></a>
cc::global_state_type&#160;</td><td class="memItemRight" valign="bottom"><b>gs</b></td></tr>
<tr class="separator:a5a873a8458d5c75fa31e514198043b7f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac11e1b958b68d4eb3f843e3370442df5"><td class="memItemLeft" align="right" valign="top"><a id="ac11e1b958b68d4eb3f843e3370442df5"></a>
ccbig::global_state_type&#160;</td><td class="memItemRight" valign="bottom"><b>gsbig</b></td></tr>
<tr class="separator:ac11e1b958b68d4eb3f843e3370442df5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2b82d5f2524d929050de97d181b6e95"><td class="memItemLeft" align="right" valign="top"><a id="ac2b82d5f2524d929050de97d181b6e95"></a>
cc&#160;</td><td class="memItemRight" valign="bottom"><b>order_0</b></td></tr>
<tr class="separator:ac2b82d5f2524d929050de97d181b6e95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a67e52b99b42396524a755ce205c3fe21"><td class="memItemLeft" align="right" valign="top"><a id="a67e52b99b42396524a755ce205c3fe21"></a>
ccbig *&#160;</td><td class="memItemRight" valign="bottom"><b>order_1</b> [alphabet_size]</td></tr>
<tr class="separator:a67e52b99b42396524a755ce205c3fe21"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9aa3b6be176a9f5d38d12a6db95d171"><td class="memItemLeft" align="right" valign="top"><a id="ac9aa3b6be176a9f5d38d12a6db95d171"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>previous_symbol</b></td></tr>
<tr class="separator:ac9aa3b6be176a9f5d38d12a6db95d171"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a0e6ea81ec57a5d041a6e0482f30a310a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0e6ea81ec57a5d041a6e0482f30a310a">&#9670;&nbsp;</a></span>entropy_encoder_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;unsigned long alphabet_size, typename entropy_encoder, typename cc, typename ccbig&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a> <a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html">dlib::entropy_encoder_model_kernel_2</a>&lt; alphabet_size, <a class="el" href="classdlib_1_1entropy__encoder.html">entropy_encoder</a>, cc, ccbig &gt;::<a class="el" href="classdlib_1_1entropy__encoder__model__kernel__2.html#a0e6ea81ec57a5d041a6e0482f30a310a">entropy_encoder_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON cc
    cc is an implementation of conditioning_class/conditioning_class_kernel_abstract.h
    cc::get_alphabet_size() == alphabet_size+1
    this will be used for the order-0 context

REQUIREMENTS ON ccbig
    ccbig is an implementation of conditioning_class/conditioning_class_kernel_abstract.h
    ccbig::get_alphabet_size() == alphabet_size+1
    this will be used for the order-1 context

INITIAL VALUE
    Initially this object's finite context model is empty
    previous_symbol == 0

CONVENTION
    &amp;get_entropy_encoder() == coder
    &amp;order_0.get_global_state() == &amp;gs
    &amp;order_1[i]-&gt;get_global_state() == &amp;gsbig


    This is an order-1-0 model. The last symbol in the order-0 and order-1
    context is an escape into the lower context.

    previous_symbol == the last symbol seen                
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="entropy__encoder__model__kernel__2_8h_source.html">entropy_encoder_model_kernel_2.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
